<template>
  <div>
    <transition
      enter-active-class="animated fadeIn moderate"
      leave-active-class="animated fadeOut moderate"
    >
      <div
        v-if="show"
        style="background: #000000aa"
        class="flex-center p-8 z-50 fixed pin bg-black"
        @click.self="close"
      >
        <button
          class="absolute pin-t pin-r mr-2 text-grey-light hover:text-grey-lightest text-3xl"
          aria-label="close"
          @click="close"
        >
          ×
        </button>
      </div>
    </transition>

    <transition
      appear
      enter-active-class="animated slideInDown moderate"
      leave-active-class="animated bounceOutUp moderate"
    >
      <div
        v-if="show"
        class="flex-center m-8 z-50 fixed pin"
        @click.self="close"
      >
        <div class="container max-h-full bg-white overflow-y-auto">
          <slot>
            Default content
          </slot>
        </div>
      </div>
    </transition>
  </div>
</template>

<script lang="ts">
import { Vue, Component, Model } from 'vue-property-decorator'

@Component
export default class Modal extends Vue {
  @Model('close') show: boolean

  mounted () {
    document.addEventListener('keyup', this.keyPress)
  }

  destroyed () {
    document.removeEventListener('keyup', this.keyPress)
  }

  keyPress ({
    keyCode
  }) {
    const escape = 27

    switch (keyCode) {
      case escape:
        this.close()
        break
    }
  }

  close () {
    this.$emit('close', false)
  }
}
</script>

<style>
</style>
